/*
 * SWE-Praktikum: Freiburg
 * 
 * Letztes Aenderungsdatum: $Date: 2015-12-10 09:41:53 +0100 (Do, 10 Dez 2015) $
 * Letzte  Revision:        $Revision: 1196 $
 * Zuletzt geaendert von:   $Author: stdasteu $
 * 
 */

#include "FinanzenTest.h"

CPPUNIT_TEST_SUITE_REGISTRATION(FinanzenTest);



void FinanzenTest::setUp(){
    // (date, umsatz, gewinn, bilanzsumme, eigenkapital)
    tm tmp = {1,1,2000};
    a = new Finanzen (tmp, 1, 1, 1, 1);
    b = new Finanzen (tmp, 100000, 100000, 100000, 100000);
    c = new Finanzen (tmp, 1000000, 1000000, 1000000, 1000000);
    d = new Finanzen (tmp, 100000, -50000, 100000, 20000);
}

void FinanzenTest::tearDown(){
    delete a;
    delete b;
    delete c;
    delete d;
}

void FinanzenTest::umsatzRenditeTest(){
    // gewinn / umsatz
    CPPUNIT_ASSERT_EQUAL (a->getUmsatzrendite(), 1.0);
    CPPUNIT_ASSERT_EQUAL (b->getUmsatzrendite(), 1.0);
    CPPUNIT_ASSERT_EQUAL (c->getUmsatzrendite(), 1.0);
    CPPUNIT_ASSERT_EQUAL (d->getUmsatzrendite(), -0.5);
}

void FinanzenTest::EKAnteilTest(){
    // eigenkapital / bilanzsumme
    CPPUNIT_ASSERT_EQUAL (a->getEKAnteil(), 1.0);
    CPPUNIT_ASSERT_EQUAL (b->getEKAnteil(), 1.0);
    CPPUNIT_ASSERT_EQUAL (c->getEKAnteil(), 1.0);
    CPPUNIT_ASSERT_EQUAL (d->getEKAnteil(), 0.2);

}