/*
 * SWE-Praktikum: Freiburg
 * 
 * Letztes Aenderungsdatum: $Date: 2016-01-09 16:51:21 +0100 (Sa, 09 Jan 2016) $
 * Letzte  Revision:        $Revision: 1658 $
 * Zuletzt geaendert von:   $Author: stvaklei $
 * 
 */

#include <cstdlib>
#include <string>
#include <iostream>
#include <iomanip>
#include <vector>
#include <ctime>
#include <cmath>
#include <sstream>
#include <fstream>
#include <ios>
#include <algorithm>
#include <unistd.h>
#include "Firma.h"
#include "Finanzen.h"

struct Wert {
    string stw= "";
    int64_t iw = 0;
    double dw = 0.0;
    int index = 0;  // Wichtig, damit wir nach dem Sortieren die Reihenfolge kennen!
    bool linReg = false;
};
struct Spalte {
    int type = 0; // Siehe #define-Zeilen unter struct
    string titel = "";
    vector<Wert> werte;
};

// Einfacher als reine Werte. Dies sind die möglichen Spaltentypen
#define StringSpalte 0
#define IntSpalte 1
#define DoubleSpalte 2


#define EUR 0
#define USD 1

#define Auswahl 0
#define Daten 1

using namespace std;

#ifndef MENUESYSTEM_H
#define	MENUESYSTEM_H

class MenueSystem {
public:

static MenueSystem* gibMenue();
   
    virtual ~MenueSystem();
    MenueSystem(vector<Firma> firmen, int jahre);
    void setAttr(vector<Firma> firmen, int jahre);
    void start();

private:
    string pad(string a, char b, int c);
    string datumString(tm date);
    int getLength(Spalte a);
    int inputInt();
    
    void rebuildFirmen();
    void tableFirmen();                 // Stellt die Firmentabelle dar
    string firmenMenue();
    string tableDaten();        // stellt die Datentabelle dar
    string datenMenue(Firma p);
    void neueSpalte();
    void deleteSpalte();
    void insertSpalte();
    void buildFirmenSpalten();
    void buildDatenSpalten();
    void displaySpalten();
    void sortSpalten();
    string promptFirma();
    void buildReihenfolge(Spalte s);
    void sortieren(Spalte tmp);
    void saveState();
    void saveHtml();
    void loadState();
    void neueVorhersage();
    void cleanFirma();
    void setloc();
    void setWaehrung();
    string intStr(int64_t i);
    string prozent(double i);
//////////////////////////////////////////
    vector<Firma> firmen;
    vector<Spalte> spalten;         // Sichtbare spalten
    vector<Spalte> hiddenSpalten;   // fuer aktuelle Tabelle moegliche Spalten
    vector<int> reihenfolge;
    vector<int> benutzteSpalten;
    int elemente;                   // Dantensaetze pro Firma
    int anzahlEintraege;            // Elemente in akt. tabelle
    int sortSpalte = 0;             // spalte nach der sortiert wird
    bool aufsteigend = false;       // Sortierrichtung
    int aktMenue = Auswahl;         // Aktuelles menue (f. speicherung)
    int findex;                     // aktuelle Firma
    int vorhersagen = 0;                // Vorhersagen in aktueller Tabelle
    int rueckrechnungen = 0;            // Rueckrechnungen in aktueller Tabelle
    int waehrung = EUR;
   // char komma [2] = {',', '.'};
    string waehrung_ISO[2] = {"EUR", "USD"};
    char trenn [2] = {'.', ','};
 static MenueSystem *instanz;
 MenueSystem(); //Singeleton
};

#endif	/* MENUESYSTEM_H */

